VERSION 5.00
Object = "{F9043C88-F6F2-101A-A3C9-08002B2F49FB}#1.2#0"; "COMDLG32.OCX"
Begin VB.Form Form1 
   Caption         =   "pic_tree"
   ClientHeight    =   1320
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   6780
   LinkTopic       =   "Form1"
   ScaleHeight     =   1320
   ScaleWidth      =   6780
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command3 
      Cancel          =   -1  'True
      Caption         =   "&Close"
      Height          =   315
      Left            =   5460
      TabIndex        =   4
      Top             =   420
      Width           =   1215
   End
   Begin VB.CheckBox Check1 
      Caption         =   "Do not list duplicate calls/variables"
      Height          =   255
      Left            =   120
      TabIndex        =   2
      Top             =   510
      Value           =   1  'Checked
      Width           =   4815
   End
   Begin VB.CommandButton Command2 
      Caption         =   "&Process"
      Height          =   315
      Left            =   5460
      TabIndex        =   3
      Top             =   60
      Width           =   1215
   End
   Begin VB.CommandButton Command1 
      Height          =   315
      Left            =   5010
      Picture         =   "Form1.frx":0000
      Style           =   1  'Graphical
      TabIndex        =   1
      Top             =   60
      Width           =   375
   End
   Begin MSComDlg.CommonDialog CommonDialog1 
      Left            =   6150
      Top             =   2490
      _ExtentX        =   847
      _ExtentY        =   847
      _Version        =   393216
   End
   Begin VB.TextBox Text1 
      Height          =   285
      Left            =   90
      TabIndex        =   0
      Text            =   "C:\Download\Electronics\Pic\3chttp.asm"
      Top             =   90
      Width           =   4815
   End
   Begin VB.Label Label2 
      Caption         =   "Status:"
      Height          =   225
      Left            =   120
      TabIndex        =   6
      Top             =   960
      Width           =   645
   End
   Begin VB.Label Label1 
      BorderStyle     =   1  'Fixed Single
      BeginProperty Font 
         Name            =   "MS Sans Serif"
         Size            =   8.25
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   255
      Left            =   900
      TabIndex        =   5
      Top             =   960
      Width           =   5775
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'pic_tree utility - 2000/01/14 J Borgaard
'public domain code
'
'Subroutine start points marked by labels having
'a colon at the end. End of subroutine indicated by
'start of next routine or EOF. Code section to be analysed
'delimited by #begin_code and #end_code directives in
'column 1. One section allowed (could be entire file of
'any size).
'
Dim db As Database

Private Sub Command1_Click()
CommonDialog1.CancelError = True
On Error GoTo ErrHandler
CommonDialog1.Filter = "MPASM (*.asm)|*.asm"
CommonDialog1.FilterIndex = 0
CommonDialog1.ShowOpen

Text1 = CommonDialog1.filename
Exit Sub
    
ErrHandler:
Exit Sub
End Sub

Private Sub Command2_Click()
'this just loads the data into the database for
'later processing.

Dim rs As Recordset
Label1 = "Loading file..": Label1.Refresh

'delete old records. Should probably compact too - not this version.
Set rs = db.OpenRecordset("SELECT * FROM table1;", dbOpenDynaset)
Do While Not rs.EOF
    rs.Delete
    rs.MoveNext
Loop

Open Text1 For Input As #1
'begin processing when we encounter "#begin_code"
Do While Not EOF(1)
    Line Input #1, x$
    If InStr(LCase$(x$), "#begin_code") > 0 Then
        foundbegin% = True
        Exit Do
    End If
Loop
If Not foundbegin% Then
    MsgBox "Error: Did not find '#begin_code' statement. Should be placed at start of actual code, usually after variable/equate statements. Terminating."
    Close #1
    Unload Me
    Exit Sub
End If
Do While Not EOF(1)
    Line Input #1, x$
    If Left$(LCase$(x$), 9) = "#end_code" Then
        'stop processing when we encounter "#end_code"
        foundend% = True
        Exit Do
    End If
    Call parseline(x$, t0$, t1$, t2$)
    If Right$(t0$, 1) = ":" Then lastsub$ = t0$
    If Left$(t0$, 1) <> ";" And Right$(t0$, 1) <> ":" Then t0$ = lastsub$
    If t1$ = "" And t2$ = "" Then t0$ = ";"
    If Left$(t0$, 1) <> ";" Then
        Select Case LCase$(t1$)
        Case "rrf", "rlf", "movwf", "clrf", "subwf", "addwf", "comf", "swapf", "andwf", "decf", "decfsz", "incf", "incfsz", "iorwf", "xorwf", "bcf", "bsf"
            'these are instructions that will modify a variable
            'there may be many others, especially when macros
            'enter the picture.
            seq& = seq& + 1
            rs.AddNew
            rs("source_object") = t0$
            rs("verb") = "modifies"
            rs("dest_object") = t2$
            rs("seq") = seq&
            rs.Update
        Case "call"
            'these are instructions for calling other routines.
            'you may want goto/bz/bnz/etc., but I didn't need that.
            seq& = seq& + 1
            rs.AddNew
            rs("source_object") = t0$
            rs("verb") = "calls"
            rs("dest_object") = t2$
            rs("seq") = seq&
            rs.Update
        End Select
    End If
    z% = DoEvents
Loop
Close #1
If Not foundend% Then
    'just a warning
    MsgBox "Warning: Did not find '#end_code' statement."
End If
Call Process
End Sub
Sub parseline(l$, t0$, t1$, t2$)
'comma, space and tabs are delimiters.
'I needed only three per line, but you may
'need more if you modify the code for
'use with macros.

delim$ = " ," & Chr$(9)
Dim t$(0 To 5)
For tmp% = 1 To Len(l$)
    If InStr(delim$, Mid$(l$, tmp%, 1)) > 0 Then
        indelim% = True
    Else
        If indelim% Then i% = i% + 1
        If i% > 3 Then Exit For
        indelim% = False
        t$(i%) = t$(i%) & Mid$(l$, tmp%, 1)
    End If
Next tmp%
t0$ = Trim$(t$(0))
t1$ = Trim$(t$(1))
t2$ = Trim$(t$(2))
End Sub

Private Sub Process()
'run through the list of routines in alpha order
'and output a listing for each.
Label1 = "Processing file..": Label1.Refresh
Dim rs As Recordset
Open App.Path & "\tree.txt" For Output As #2
Set rs = db.OpenRecordset("SELECT DISTINCT source_object FROM table1 ORDER BY source_object;", dbOpenSnapshot)
If Not rs.EOF Then rs.MoveLast
rc& = rs.RecordCount
If Not rs.EOF Then rs.MoveFirst
Do While Not rs.EOF
    TreeSub rs("source_object"), 0
    
    'I have a slow machine. Nice to know how much longer :)
    ri& = ri& + 1
    Label1 = Format$(ri& / rc&, "0.0%") & " completed": Label1.Refresh
    
    z% = DoEvents
    rs.MoveNext
Loop
Label1 = "Done. Results in " & App.Path & "\tree.txt"
Close #2
End Sub
Sub TreeSub(obj$, level%)
'recursive subroutine to drill down into the
'various routines and list the variables modified
'and calls made by each.
Dim rs As Recordset
If level% > 0 Then
    Print #2, String$(level%, Chr$(9)) & ">" & obj$
Else
    Print #2, String$(level%, Chr$(9)) & "[" & obj$ & "]"
End If
If Check1 = 1 Then
    'a unique listing in alpha order of calls and
    'modified variables. Does not represent actual
    'order of execution - for a quick look.
    Set rs = db.OpenRecordset("SELECT DISTINCT source_object,verb,dest_object FROM table1 WHERE source_object='" & obj$ & "' ORDER BY verb DESC, dest_object;", dbOpenSnapshot)
Else
    'shows actual order of execution as the calls
    'and variable writes occur, including duplicate
    'calls and writes.
    Set rs = db.OpenRecordset("SELECT * FROM table1 WHERE source_object='" & obj$ & "' ORDER BY seq;", dbOpenSnapshot)
End If
Do While Not rs.EOF
    Select Case rs("verb")
    Case "modifies"
        Print #2, String$(level%, Chr$(9)) & " *" & rs("dest_object") & "*"
    Case "calls"
        'recursive call, next level
        TreeSub rs("dest_object") & ":", level% + 1
    End Select
    rs.MoveNext
Loop
End Sub

Private Sub Command3_Click()
Unload Me
End Sub

Private Sub Form_Load()
'load last file info - save typing
On Error Resume Next
Open App.Path & "\lastfile.txt" For Input As #1
Line Input #1, x$
Text1 = x$
Close #1
On Error GoTo 0

'open database
Set db = OpenDatabase(App.Path & "\pic_tree.mdb")

End Sub

Private Sub Form_Unload(Cancel As Integer)
'save file info for next session
Open App.Path & "\lastfile.txt" For Output As #1
Print #1, Text1
Close #1

End Sub
